% Subroutine for computing "theta" via linear programming
% Coded by Jianhui Chen (jianhui.chen@asu.edu, Arizona State University)

function [ theta zeta f A, b B c l u ] = compute_theta_lpprog_joint(G, alpha, H, f, A, b, B, c, l, u)

len = length(G);
num_c = size(H, 2);

%f = [ -1; zeros( len, 1 ) ]; 
%A = [ ] ; b = [ ] ;
%for i = 1:num_alpha_set
% alpha_array = [ ];
% alpha_array = alpha_set{ i };

s = [ ];
    
for j = 1:len
    s( j ) = 0;
    for cc = 1:num_c
        s( j ) = s( j ) + 1/4 * alpha(:,cc)' * G{ j } * alpha(:,cc) - alpha(:,cc)' * H(:,cc);
            %+ 1/4 * alpha(:,cc)' * alpha(:,cc) - alpha(:,cc)' * H(:,cc);
    end
end
    
A = [ A ; [ -1 s] ; [ 1 -s ] ] ;
b = [ b ; +inf ; 0] ;
    
%A = [ A ; - A ] ;
%b = [ b  ; zeros( length(b), 1 )  ] ;
%b  = [ b ; 0 ];

%B = [ 0 ones(1, len) ];
%c = [ 1 ] ;

%l = [ -inf ; zeros(len,1) ] ;
%u = [ +inf ; ones(len,1) ] ;

result = linprog( f, A, b , B, c, l , u ); 
zeta = result(1);
theta = result(2:end);


